/**
 * Alibaba.com Inc.
 * Copyright (c) 2004-2016 All Rights Reserved.
 */
package com.aliyun.iot;

import com.aliyun.iot.message.AbstractMessage;
import com.aliyun.iot.message.ConnectACK;

/**
 * 消息监听客户端
 * 由客户端自定义实现，session收到消息会回调通知
 * @version $Id: CcpMessageListener.java,v 0.1 2016年4月15日 下午2:14:43  Exp $
 */
public interface CcpMessageListener {
    
    
    /** 
     * 消息回调函数
     * @param message
     */
    public void onMessage(AbstractMessage message);
    
    /**
     * 上线通知
     * 
     * @param message
     */
    public void onConnect(ConnectACK message);
    
    /**
     * 离线通知
     */
    public void onOffLine();

}
