/**
 * Alibaba.com Inc.
 * Copyright (c) 2004-2016 All Rights Reserved.
 */
package com.aliyun.iot.connect;

import java.security.Key;

/**
 * ccp连接所需参数
 *
 * @version $Id: ConnectOpts.java,v 0.1 2016年6月7日 下午8:09:41  Exp $
 */
public class ConnectOpts {

    /** 认证服务器地址 **/
    private String authUrl          = "http://manager.channel.aliyun.com";

    /** sign 签名算法   HmacMD5（默认） 或 HmacSHA1 或 md5 **/
    private String signMethod       = "HmacMD5";

    /** 产品证书的key，可以在控制台页面上查看 **/
    private String productAppKey    = null;

    /** 产品证书的key，可以在控制台页面上查看 **/
    private String productAppSecret = null;

    /** 某个设备的id，可以在设备管理页面上查看 **/
    private String deviceId         = null;
    
    /** 某个设备的名称，可以在设备管理页面上查看 **/
    private String deviceName         = null;

    /** 某个设备的秘钥，可以在设备管理页面上查看 **/
    private String deviceSecret     = null;

    /** ping pong 心跳时间 最少60秒 **/
    private short    aliveSeconds     = 60;
    
    /** 是否自动重连 **/
    private boolean                   autoReconnect      = true;
    /** 重练间隔时间，最小5000 单位毫秒 **/
    private int                       autoReconnectDelay = 5000;

    /** 私钥证书对象  **/
    private Key    pkey;

    /**
     * Getter method for property <tt>authUrl</tt>.
     * 
     * @return property value of authUrl
     */
    public String getAuthUrl() {
        return authUrl;
    }

    /**
     * Setter method for property <tt>authUrl</tt>.
     * 
     * @param authUrl value to be assigned to property authUrl
     */
    public void setAuthUrl(String authUrl) {
        this.authUrl = authUrl;
    }

    /**
     * Getter method for property <tt>productAppKey</tt>.
     * 
     * @return property value of productAppKey
     */
    public String getProductAppKey() {
        return productAppKey;
    }

    /**
     * Setter method for property <tt>productAppKey</tt>.
     * 
     * @param productAppKey value to be assigned to property productAppKey
     */
    public void setProductAppKey(String productAppKey) {
        this.productAppKey = productAppKey;
    }

    /**
     * Getter method for property <tt>productAppSecret</tt>.
     * 
     * @return property value of productAppSecret
     */
    public String getProductAppSecret() {
        return productAppSecret;
    }

    /**
     * Setter method for property <tt>productAppSecret</tt>.
     * 
     * @param productAppSecret value to be assigned to property productAppSecret
     */
    public void setProductAppSecret(String productAppSecret) {
        this.productAppSecret = productAppSecret;
    }

    /**
     * Getter method for property <tt>deviceId</tt>.
     * 
     * @return property value of deviceId
     */
    public String getDeviceId() {
        return deviceId;
    }

    /**
     * Setter method for property <tt>deviceId</tt>.
     * 
     * @param deviceId value to be assigned to property deviceId
     */
    public void setDeviceId(String deviceId) {
        this.deviceId = deviceId;
    }

    /**
     * Getter method for property <tt>deviceSecret</tt>.
     * 
     * @return property value of deviceSecret
     */
    public String getDeviceSecret() {
        return deviceSecret;
    }

    /**
     * Setter method for property <tt>deviceSecret</tt>.
     * 
     * @param deviceSecret value to be assigned to property deviceSecret
     */
    public void setDeviceSecret(String deviceSecret) {
        this.deviceSecret = deviceSecret;
    }

    /**
     * Getter method for property <tt>aliveSeconds</tt>.
     * 
     * @return property value of aliveSeconds
     */
    public short getAliveSeconds() {
        return aliveSeconds;
    }

    /**
     * Setter method for property <tt>aliveSeconds</tt>.
     * 
     * @param aliveSeconds value to be assigned to property aliveSeconds
     */
    public void setAliveSeconds(short aliveSeconds) {
        this.aliveSeconds = aliveSeconds;
    }

    /**
     * Getter method for property <tt>signMethod</tt>.
     * 
     * @return property value of signMethod
     */
    public String getSignMethod() {
        return signMethod;
    }

    /**
     * Setter method for property <tt>signMethod</tt>.
     * 
     * @param signMethod value to be assigned to property signMethod
     */
    public void setSignMethod(String signMethod) {
        this.signMethod = signMethod;
    }

    /**
     * Getter method for property <tt>pkey</tt>.
     * 
     * @return property value of pkey
     */
    public Key getPkey() {
        return pkey;
    }

    /**
     * Setter method for property <tt>pkey</tt>.
     * 
     * @param pkey value to be assigned to property pkey
     */
    public void setPkey(Key pkey) {
        this.pkey = pkey;
    }

    /**
     * Getter method for property <tt>autoReconnect</tt>.
     * 
     * @return property value of autoReconnect
     */
    public boolean isAutoReconnect() {
        return autoReconnect;
    }

    /**
     * Setter method for property <tt>autoReconnect</tt>.
     * 
     * @param autoReconnect value to be assigned to property autoReconnect
     */
    public void setAutoReconnect(boolean autoReconnect) {
        this.autoReconnect = autoReconnect;
    }

    /**
     * Getter method for property <tt>autoReconnectDelay</tt>.
     * 
     * @return property value of autoReconnectDelay
     */
    public int getAutoReconnectDelay() {
        return autoReconnectDelay;
    }

    /**
     * Setter method for property <tt>autoReconnectDelay</tt>.
     * 
     * @param autoReconnectDelay value to be assigned to property autoReconnectDelay
     */
    public void setAutoReconnectDelay(int autoReconnectDelay) {
        this.autoReconnectDelay = autoReconnectDelay;
    }

    /**
     * Getter method for property <tt>deviceName</tt>.
     * 
     * @return property value of deviceName
     */
    public String getDeviceName() {
        return deviceName;
    }

    /**
     * Setter method for property <tt>deviceName</tt>.
     * 
     * @param deviceName value to be assigned to property deviceName
     */
    public void setDeviceName(String deviceName) {
        this.deviceName = deviceName;
    }

    
}
