package com.aliyun.iot.message;

import com.aliyun.iot.util.DynamicByteBuffer;
import com.aliyun.iot.util.ProtocolUtils;

/**
 * 退出连接
 * Created by Gary on 14-5-5.
 */
public class Disconnect extends AbstractMessage {

    /** token 在连接的 ack服务器有返回 **/
    public String connectionToken;

    public Disconnect(){
        super(DISCONNECT);
    }

    public Disconnect(MessageHeader fixedHeader){
        super(fixedHeader);
    }

    @Override
    public byte[] encodeBody() {
        DynamicByteBuffer data = DynamicByteBuffer.allocate(128);
        data.put(ProtocolUtils.encodeString(this.connectionToken));
        return data.array();
    }

    @Override
    public void decodeBody(DynamicByteBuffer buffer){
        this.connectionToken = ProtocolUtils.decodeString(buffer);
    }
}
