package com.aliyun.iot.message;

import com.aliyun.iot.util.DynamicByteBuffer;
import com.aliyun.iot.util.ProtocolUtils;

/**
 * pubAck 指令 client <---> server,A PUBACK Packet is the response to a PUBLISH Packet.
 */
public class PubAck extends AbstractMessage {

    public byte code; // 比标准的mqtt增加一个code,表明pub成功或失败,0表示成功，其他为失败,1为没有权限,其他未知的为10

    public PubAck() {
        super(PUBACK);
    }

    public PubAck(MessageHeader header) {
        super(header);
    }

    @Override
    public byte[] encodeBody() {
        DynamicByteBuffer data = DynamicByteBuffer.allocate(128);
        // SequenceID
        ProtocolUtils.encodeVariableNumber(data, this.sequenceID);
        // 表明pub成功或失败,0表示成功，其他为失败,1为没有权限,其他未知的为10
        data.put(code);
        return data.array();
    }

    @Override
    public void decodeBody(DynamicByteBuffer buffer) {
        // SequenceID
        this.sequenceID = (int) ProtocolUtils.decodeVariableNumber(buffer);
        // 表明pub成功或失败,0表示成功，其他为失败,1为没有权限,其他未知的为10
        this.code = buffer.get();

    }

    @Override
    public String toString() {
        return "PubAck[sequenceID:+" + sequenceID + ",code:" + code + "]";
    }

}
