package com.aliyun.iot.message;

import java.util.Map;

import com.aliyun.iot.util.DynamicByteBuffer;
import com.aliyun.iot.util.HeaderUtils;
import com.aliyun.iot.util.ProtocolUtils;

public class Response extends AbstractMessage {

    public StatusCode          statusCode     = StatusCode.success;

    public byte[]              payload;

    //payload对应属性
    public StatusCode          responseStatus = StatusCode.success;
    public byte                contentType;
    public Map<String, Object> headers;
    public int                 resConfigLength;
    public String              resourceMeta;
    public byte[]              body           = new byte[0];

    public Response() {
        super(RESPONSE);
    }

    public Response(MessageHeader fixedHeader) {

        super(fixedHeader);
    }

    @Override
    public byte[] encodeBody() {
        return null;
    }

    @Override
    public void decodeBody(DynamicByteBuffer buffer) {

        // 读出sequenceID
        this.sequenceID = (int) ProtocolUtils.decodeVariableNumber(buffer);

        // 读出statusCode
        this.statusCode = StatusCode.from((int) ProtocolUtils.decodeVariableNumber(buffer));

        if (statusCode == StatusCode.success) {
            // 读出statusCode
            responseStatus = StatusCode.from((int) ProtocolUtils.decodeVariableNumber(buffer));
            contentType = buffer.get();
            headers = HeaderUtils.decodeHeader(buffer);
            resConfigLength = (int) ProtocolUtils.decodeVariableNumber(buffer);
            if (resConfigLength > 0) {
                resourceMeta = ProtocolUtils.decodeString(buffer);
            }
            byte[] bytes = new byte[buffer.remaining()];
            buffer.get(bytes);
            body = bytes;
        }
    }

    @Override
    public String toString() {
        return "Response [statusCode=" + statusCode + ", sequenceId:" + sequenceID + ",contentType="
               + contentType + ",headers=" + headers + ",resourceMeta=" + resourceMeta + "]:"
               + new String(body);
    }

}
