package com.aliyun.iot.message;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by Gary on 14-5-7.
 */
public enum StatusCode {

    success(0x00), // 连接成功
    connecting(1000),//连接中
    reconnecting(3000),//重新连接中
    offline(2000),//连接断线

    reject_version_mismatch(0x01), // 拒绝连接：协议版本不正确
    reject_identity_invalid(0x02), // 拒绝连接：身份验证无效
    reject_ca_expired(0x03), // 拒绝连接：证书已过期
    reject_invalid_token(0x04), // 拒绝连接：无效的Token
    reject_untrust_data(0x05), // 拒绝访问：不可信的数据内容
    reject_token_expired(0x06), // 拒绝访问：Token已经过期
    reject_unknow_error(0x07), // 没知错误，比如：服务器内部错误
    reject_illega_packageName(0x08), // app认证packageName不对
    reject_rpc_invoke_fail(9), // rpc调用出错
    reject_invalid_sid(10);

    private static Map<Integer, StatusCode> map = new HashMap<Integer, StatusCode>();

    static {

        for (StatusCode p : StatusCode.values()) {

            StatusCode.map.put(p.code, p);
        }
    }

    private int                             code;

    StatusCode(int code){

        this.code = code;
    }

    public static StatusCode from(int code) {

        return map.get(code);
    }

    public int code() {
        return code;
    }
}
