package com.aliyun.iot.message;

import com.aliyun.iot.util.DynamicByteBuffer;
import com.aliyun.iot.util.EncryptType;

/**
 * Created by Gary on 14-5-5.
 */
public class UnknownSession extends AbstractMessage {

    public StatusCode statusCode = StatusCode.reject_ca_expired; // 连接返回的状态码

    public byte       sourceMessageType;                        // 产生未知会话的来源协议类型

    public UnknownSession() {

        super(UNKNOWN_SESSION);
    }

    public UnknownSession(MessageHeader fixedHeader) {

        super(fixedHeader);
    }

    @Override
    public byte[] encodeBody() {

        DynamicByteBuffer data = DynamicByteBuffer.allocate(128);

        // Source Message Type
        data.put(this.sourceMessageType);
        // StatusCode
        data.put((byte) this.statusCode.code());

        return data.array();
    }

    @Override
    public void decodeBody(DynamicByteBuffer buffer) {

        // Source Message Type
        this.sourceMessageType = buffer.get();
        // StatusCode
        this.statusCode = StatusCode.from(buffer.get());
    }

    public EncryptType getEncryptType() {

        return EncryptType.noNeed;
    }

    @Override
    public String toString() {
        return super.toString() + "; UnknownSession{" + "sourceMessageType=" + sourceMessageType
               + ",statusCode=" + statusCode + '}';
    }
}
